void reload_shortcuts(void)
{
    while(shortcut_count)
    {
      free(desktop_shortcuts[--shortcut_count].icon);
      free(desktop_shortcuts[shortcut_count].icon_path);
    }
    free(desktop_shortcuts);
    if(!load_desktop_shortcuts())
    {
      video_mode(0x03);
      printf("Critical out of memory error!");
      abort();
    }

}

int newsc_program(struct prog_window *window, int args, struct mouse_status *mouse, int *keypress)
{
  if(keypress)
  {
    switch(*keypress)
    {
      case 83: case 115:
        args=0;
        break;
      case 82: case 114:
        args=1;
        break;
    }
    *keypress = -1;
  }
    
  if(!args)
  {
    if(edit_text(window, 1, mouse) == 13)
      args=1;
  }
  if(args == 1)
  {
    run_program(0, "SCEDITOR.COM", window->window_grid[1]->text, mouse, 0);
    
    reload_shortcuts();

    del_window(window);
    draw_mouse_cursor(mouse, VGA, 1);
    return -101;
  }

  
  return args+100; 
}

struct prog_window *newsc_window(void)
{
  struct prog_window *retval = new_window(-1, -1, 250, 60, "New shortcut", 0, 1, 1, "ICONS/SCEDITOR.ICO", &newsc_program);

  if(!retval)
  {
    nomemory:
    if(retval) del_window(retval);
    nomemory(0);
    return 0;
  }

  if(!(window_text(retval, 5, 5, "\021Shortcut filename:", _WINDOW_BASICTEXTCOLOR)))
    goto nomemory;

  if(!(window_textbox(retval, 110, 5, 100, _FONT_HEIGHT+2, "DESKTOP\\", 81)))
    goto nomemory;    

  if(!(window_button(retval, 10, 5+(_FONT_HEIGHT+8), 150, _FONT_HEIGHT+2, "\021Run shortcut editor", _WINDOW_BASICTEXTCOLOR)))
    goto nomemory;

  draw_window(retval, 1, 0);
  
  return retval;
}

void reload_config(struct mouse_status *mouse)
{
  load_settings();
  free(system_font);
  load_system_font(system_font_file, &system_font);  
  video_mode(video);
  draw_screen();
  draw_mouse_cursor(mouse, VGA, 1);  
}

int cpanel_getkb(int *key, int args)
{
  switch (*key)
  {
    case 99: case 67:
      return 0;
    case 102: case 70:
      return 1;
    case 110: case 78:
      return 2;
    case 97: case 65:
      return 3;
    default:
      return args;
  }
}

int cpanel_program(struct prog_window *window, int args, struct mouse_status *mouse, int *keypress)
{
  if(keypress)
  {
    args = cpanel_getkb(keypress, args);
    *keypress = -1;
  }

  // config
  if(!args)
  {
    run_program(0, "CONFIG.COM", 0, mouse, 0);
    reload_config(mouse);
  }
  // default programs
  else if(args == 1)
  {
    run_program(0, "ASCSFX.COM", 0, mouse, 0);
  }
  else if(args == 2)
  {
    newsc_window();
    draw_mouse_cursor(mouse, VGA, 1);            
  }
  else if(args == 3)
  {
    dialog(20, 20, 250, 50, 0, 0, 0, versioninfo, "Info", 0, mouse);    
  }
  return args+100; 
}

struct prog_window *init_cpanel_window(void)
{
  struct prog_window *retval = new_window(-1, -1, 250, 70, "Control Panel", 0, 1, 1, "ICONS/CPANEL.ICO", &cpanel_program);

  if(!retval)
  {
    nomemory:
    if(retval) del_window(retval);
    nomemory(0);
    return 0;
  }

  if(!(window_icon(retval, 10, 5, "\021Configuration", "ICONS/CONFIG.ICO")))
    goto nomemory;
  if(!(window_icon(retval, 90, 5, "\021File types", "ICONS/ASCSFX.ICO")))
    goto nomemory;      
  if(!(window_icon(retval, 170, 5, "\021New shortcut", "ICONS/SCEDITOR.ICO")))
    goto nomemory;      
  if(!(window_button(retval, 10, 50, 150, _FONT_HEIGHT+2, "\021About FreeDOSShell", _WINDOW_BASICTEXTCOLOR)))
    goto nomemory;

  draw_window(retval, 1, 0);
  
  return retval;
}
