void (__interrupt __far *prev_int_24)(void); 

/*
Sets the original 0x24 interrupt
*/
void reset_int24(void)
{
  _dos_setvect( 0x24, prev_int_24 );
}

  char errormsg[100];
  char error1[] = "error while";
  char *error2[] = { "reading", "writing" };
  char *error3[] = { "DOS area", "FAT", "root", "file" };

  char *dierror[] = {
  "Write protection",
  "Unknown drive",
  "Drive not ready",
  "Invalid command",
  "Data",
  "Incorrect length of request",
  "Seek",
  "Invalid format",
  "Sector not found",
  "Out of paper",
  "Write",
  "Read",
  "General",
  "Inappropriate disk change"
  };

/*
This is a critical error handler
*/
void __interrupt int24handler(union INTPACK r)
{
  unsigned char device;
  unsigned int reg_di;
  unsigned char errorbits;
//  union REGS regs;
  __asm
  {
    mov device, al
    mov errorbits, ah
    mov reg_di, di
  }
  reg_di <<= 8;
  reg_di >>= 8;

  if(errorbits & 0x80)
    sprintf(errormsg, "%s %s %s %s.", dierror[reg_di], error1, error2[errorbits&0x01], error3[(errorbits>>1)&0x03]);
  else
    sprintf(errormsg, "%s %s %s %s at device %u.", dierror[reg_di], error1, error2[errorbits&0x01], error3[(errorbits>>1)&0x03], device);  
/*    if(!is_cdrom)
      sprintf(errormsg, "%s %s %s %s at device %u.", dierror[reg_di], error1, error2[errorbits&0x01], error3[(errorbits>>1)&0x03], device);
    else*/
//      sprintf(errormsg, "%s %s %s %s at CD-ROM.", dierror[reg_di], error1, error2[0], error3[(errorbits>>1)&0x03]);
//  is_cdrom=0;
  
  
  dialog(20, 20, 350, 50, 0, 0, 1, errormsg, "I/O Error", 0, 0);

  r.h.al = 0x03;
  
}

/*#pragma aux int24handler aborts
void __far int24handler(void)
{
  __asm
  {
    call int24handler_ui
    mov al, 0x03
    iret
  }
}*/

/*
Sets the interrupt 0x24
*/
void set_int24(void)
{
  prev_int_24 = _dos_getvect( 0x24 ); 
  _dos_setvect(0x24, int24handler);
}
