/*
  This function is the handler for editing text in textboxes
  
  Returns: 0 if the user presses ESC,
    1 if ENTER,
    2 if TAB
*/
int edit_text(struct prog_window *window, unsigned int textbox, struct mouse_status *mouse)
{
  unsigned char *textp = window->window_grid[textbox]->text;
  unsigned int m;
  struct text_print texts;
  int c;
  unsigned int caretpos;
  unsigned int textl;
  unsigned char *ltextp = textp;

  draw_mouse_cursor(mouse, VGA, 2);                          

  draw_rectangle(window->x+window->window_grid[textbox]->x, window->y+_FONT_HEIGHT+2+window->window_grid[textbox]->y,
          window->window_grid[textbox]->width, window->window_grid[textbox]->height, _TEXTBOX_ABGCOLOR, VGA);    

  texts = cprint_text(window->x+window->window_grid[textbox]->x+2,
      window->y+4+_FONT_HEIGHT+window->window_grid[textbox]->y, ltextp, _TEXTBOX_TEXTCOLOR, _FONT_HEIGHT, mouse->pointer_x+8, 0);

  caretpos = texts.text - textp;
  
/*  if(!*(texts.text-1))
  {
    caretpos--;
    texts.text--;
  }*/

  // draw caret
  draw_line(texts.x-1, window->y+3+_FONT_HEIGHT+window->window_grid[textbox]->y, texts.x-1, window->y+2+(2*_FONT_HEIGHT)+window->window_grid[textbox]->y, _TEXTBOX_TEXTCOLOR, VGA);

  texts = cprint_text(texts.x,
    window->y+4+_FONT_HEIGHT+window->window_grid[textbox]->y, texts.text, _TEXTBOX_TEXTCOLOR, _FONT_HEIGHT, window->x+window->window_grid[textbox]->x+window->window_grid[textbox]->width, 0);
  while(*texts.text)
    texts.text++;
  textl = texts.text-textp;

  while(1)
  {
    if(!(c = getch()))
    {
      switch(getch())
      {
        case 75: if(caretpos) caretpos--; break;
        case 77: if(caretpos < textl) caretpos++; break;
        case 71: caretpos=0; ltextp=textp; break;
        case 79: caretpos=textl; if(textl>10) ltextp=&textp[textl]-10; break;
        case 83:
        // delete
          for(m=caretpos;textp[m];m++)
            textp[m] = textp[m+1];
        break;
      }
    }
    else
    {
      switch(c)
      {
        case 27: case 13: case 9:
          window_drawelement(window, textbox);
          draw_mouse_cursor(mouse, VGA, 1);
          if(c == 27)
            return 0;
          if(c == 13)
            return 1;
          if(c == 9)
            return 2;
        case 8:
        // backspace
          if(caretpos)
          {
//            for(m=--caretpos;m<textl;m++)
            for(m=--caretpos;textp[m];m++)
              textp[m] = textp[m+1];
//            textl--;
          }
        break;
        default:
          if(textl < window->window_grid[textbox]->c)
          {
            for(m=textl;m>caretpos;m--)
              textp[m] = textp[m-1];
            textp[caretpos++] = c;
          }
        break;
      }
    }
    draw_rectangle(window->x+window->window_grid[textbox]->x, window->y+_FONT_HEIGHT+2+window->window_grid[textbox]->y,
          window->window_grid[textbox]->width, window->window_grid[textbox]->height, _TEXTBOX_ABGCOLOR, VGA);    

    texts = cprint_text(window->x+window->window_grid[textbox]->x+2,
      window->y+4+_FONT_HEIGHT+window->window_grid[textbox]->y, ltextp, _TEXTBOX_TEXTCOLOR, _FONT_HEIGHT,
      window->x+window->window_grid[textbox]->x+window->window_grid[textbox]->width, caretpos-(ltextp-textp));

    if(caretpos && texts.x > window->x+window->window_grid[textbox]->x+window->window_grid[textbox]->width -30)
    {
      ltextp++;
      if(texts.x > window->x+window->window_grid[textbox]->x+window->window_grid[textbox]->width -10)
        ltextp+=4;
    }
    else if(texts.x < window->x+window->window_grid[textbox]->x+30 && ltextp>textp)
    {
      ltextp--;
      if(texts.x < window->x+window->window_grid[textbox]->x+10 && ltextp>textp)
        ltextp-=4;
    }     
      
    if(caretpos)
    {
      draw_line(texts.x-1, window->y+3+_FONT_HEIGHT+window->window_grid[textbox]->y, texts.x-1, window->y+2+(2*_FONT_HEIGHT)+window->window_grid[textbox]->y, _TEXTBOX_TEXTCOLOR, VGA);

      texts = cprint_text(texts.x,
        window->y+4+_FONT_HEIGHT+window->window_grid[textbox]->y, texts.text, _TEXTBOX_TEXTCOLOR, _FONT_HEIGHT, window->x+window->window_grid[textbox]->x+window->window_grid[textbox]->width, textl);
    }
    else
      draw_line(window->x+window->window_grid[textbox]->x+1, window->y+3+_FONT_HEIGHT+window->window_grid[textbox]->y, window->x+window->window_grid[textbox]->x+1, window->y+2+(2*_FONT_HEIGHT)+window->window_grid[textbox]->y, _TEXTBOX_TEXTCOLOR, VGA);        
    while(*texts.text)
      texts.text++;
    textl = texts.text-textp;

  }
}
